<?php

namespace EventPortal\Domain\Component;

use EventPortal\Domain\Util\Parameters;
use EventPortal\Enums\InertiaMethod;
use Illuminate\Support\Arr;

class Button extends Component
{
    const TYPE = 'Button';

    /** @var InertiaMethod */
    public $method;

    /** @var string|null */
    public $route;

    /** @var string|null */
    public $variant = 'primary';

    /** @var array */
    public $routeParams = [];

    /** @var string|null */
    public $icon;

    public function method(InertiaMethod $method): self
    {
        $this->method = $method->getValue();

        return $this;
    }

    /**
     * @param string|array $parameters
     */
    public function route(string $route, $parameters = []): self
    {
        $this->route = $route;

        if ($parameters) {
            $this->routeParams = Parameters::make(Arr::wrap($parameters))->asPlain()->asArray();
        }

        return $this;
    }

    public function variant(string $variant): self
    {
        $this->variant = $variant;

        return $this;
    }

    public function icon(string $icon): self
    {
        $this->icon = $icon;

        return $this;
    }
}
